#  Copyright (c) 2023. Berlin Institute of Health (BIH) and Deutsches Krebsforschungszentrum (DKFZ).
#
#  Distributed under the MIT License. Full text at
#
#        https://gitlab.com/one-touch-pipeline/weskit/openstack-vms/-/blob/master/LICENSE
#
#  Authors: The WESkit Team

---
- name: Ensure /etc/rc.d/rc.local is executable
  ansible.builtin.file:
    path: /etc/rc.d/rc.local
    mode: u=rwx,g=rx,o=rx

- name: Enable "rc-local" systemd service (deprecated)
  ansible.builtin.systemd:
    name: rc-local
    enabled: yes

# https://www.techandme.se/performance-tips-for-redis-cache-server/
- name: Configure somaxconn (for Redis)
  ansible.builtin.lineinfile:
    path: /etc/sysctl.conf
    line: net.core.somaxconn = 65535

- name: Runtime enable overcommit memory (for Redis)
  ansible.builtin.shell: sysctl net.core.somaxconn=65535

- name: Configure enable overcommit memory (for Redis)
  ansible.builtin.lineinfile:
    path: /etc/sysctl.conf
    line: vm.overcommit_memory = 1

- name: Runtime enable overcommit memory (for Redis)
  ansible.builtin.shell: sysctl vm.overcommit_memory=1

- name: Configure transparent hugepages (for Redis & MongoDB)
  ansible.builtin.lineinfile:
    path: /etc/rc.d/rc.local
    line: echo never > /sys/kernel/mm/transparent_hugepage/enabled

- name: Runtime enable transparent hugepages (for Redis & MongoDB)
  ansible.builtin.shell: echo never > /sys/kernel/mm/transparent_hugepage/enabled

- name: Configure transparent hugepages defrag (for MongoDB)
  ansible.builtin.lineinfile:
    path: /etc/rc.d/rc.local
    line: echo never > /sys/kernel/mm/transparent_hugepage/defrag

- name: Runtime enable transparent hugepages defrag (for MongoDB)
  ansible.builtin.shell: echo never > /sys/kernel/mm/transparent_hugepage/defrag

# Install Miniconda

# Install Mamba

# Git clone api repo

# Git clone production deployment repo

# Create user to run WESkit
- name: Ensure group/gid for WESkit container
  group:
    name: "{{ weskit_group }}"
    gid: "{{ weskit_gid}}"
    state: present

- name: Ensure user/uid for WESkit container
  user:
    name: "{{ weskit_user }}"
    uid: "{{ weskit_uid }}"
    group: "{{ weskit_group }}"
    state: present

# Build container for user (weskit-api:$user)

# Setup configuration (weskit-production-setup)

# Start service
